# -----------------------------------------------------------------------------
#   $RCSfile: ShoppingSec.mak,v $
#  
#   See Copyright for the status of this software.
#  
#   The OpenSOAP Project
#   http://opensoap.jp/
# -----------------------------------------------------------------------------

# temporary 1.0-20030110
prefix=/usr/local/opensoap
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL_PROGRAM=install -c
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSMLDIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES = ShoppingClientSec
#
cgi_client_PROGRAMFILES = ShoppingClientSec.cgi

CLIENT_HTML_DIR = ShoppingHtml
CLIENT_HTML_FILES = \
	$(CLIENT_HTML_DIR)/CommonFtr.html \
	$(CLIENT_HTML_DIR)/CommonHdr.html \
	$(CLIENT_HTML_DIR)/ErrorFtr.html \
	$(CLIENT_HTML_DIR)/ErrorHdr.html \
	$(CLIENT_HTML_DIR)/GetProductList.html \
	$(CLIENT_HTML_DIR)/GetProductListFtr.html \
	$(CLIENT_HTML_DIR)/GetProductListHdr.html \
	$(CLIENT_HTML_DIR)/GetStockQtyErr.html \
	$(CLIENT_HTML_DIR)/GetStockQtyFtr.html \
	$(CLIENT_HTML_DIR)/GetStockQtyHdr.html \
	$(CLIENT_HTML_DIR)/OrderResultErr.html \
	$(CLIENT_HTML_DIR)/OrderResultFtr.html \
	$(CLIENT_HTML_DIR)/OrderResultHdr.html \
	$(CLIENT_HTML_DIR)/PlaceOrderErr.html \
	$(CLIENT_HTML_DIR)/PlaceOrderFtr.html \
	$(CLIENT_HTML_DIR)/PlaceOrderHdr.html

cgi_client_USEKEYFILES = \
	 	pubKey_ShoppingService.pem \
		privKey_ShoppingClient.pem

#
cgi_service_PROGRAMFILES = ShoppingServiceSec.cgi

#
service_USEKEYFILES = \
	 	privKey_ShoppingService.pem \
		pubKey_ShoppingClient.pem \
		Shopping.keys

servicerootdir=/var/tmp/Shopping
serviceconfdir=$(servicerootdir)/conf
servicedatadir=$(servicerootdir)/data
servicekeysdir=$(servicerootdir)/keys
service_CONFFILES = Shopping.conf
service_DATAFILES = ProductSpec.data ProductStock.data

#
stdio_service_PROGRAMFILES = ShoppingServiceSec
SSML_FILES = ShoppingSec.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(cgi_client_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS) -lcrypto
#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS= -I$(OPENSOAP_INCLUDE)
# CFLAGS=-g -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE_CGI
CLIENT_CGI_CFLAGS=$(CFLAGS) -DCLIENT_CGI

COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService -lOpenSOAPSecurity -lOpenSOAPClient $(COMMON_LIBS)

#
SOURCES = \
	ClSecCmn.c \
	ClCmn.c \
	ShClCmn.c \
	ShClProductList.c \
	ShClGetProductCount.c \
	ShClGetProductSpec.c \
	ShClGetStockQty.c \
	ShClPlaceOrderCmn.c \
	ShClPlaceOrderSec.c \
	ShClMainSec.c \
	ShClMainSecWeb.c \
	SvCmn.c \
	SvSecCmn.c \
	ShSvCmn.c \
	ShSvGetProductCount.c \
	ShSvGetProductSpec.c \
	ShSvGetStockQty.c \
	ShSvPlaceOrderSec.c \
	ShSvMainSec.c

OBJS=$(SOURCES:.c=.o) ShSvMainSec.cgi.o


all: $(PROGRAMS)


## Make Client Programs

ShoppingClientSec: \
	ClCmn.o \
	ClSecCmn.o \
	ShClCmn.o \
	ShClProductList.o \
	ShClGetProductCount.o \
	ShClGetProductSpec.o \
	ShClGetStockQty.o \
	ShClPlaceOrderCmn.o \
	ShClPlaceOrderSec.o \
	ShClMainSec.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

ShoppingClientSec.cgi: \
	ClCmn.o \
	ClSecCmn.o \
	ShClCmn.o \
	ShClProductList.o \
	ShClGetProductCount.o \
	ShClGetProductSpec.o \
	ShClGetStockQty.o \
	ShClPlaceOrderCmn.o \
	ShClPlaceOrderSec.o \
	ShClMainSecWeb.o
	$(CC)  -o $@ $^ $(CLIENT_LDFLAGS)

## Make Service Programs

ShoppingServiceSec: \
	SvCmn.o \
	SvSecCmn.o \
	ShSvCmn.o \
	ShSvGetProductCount.o \
	ShSvGetProductSpec.o \
	ShSvGetStockQty.o \
	ShSvPlaceOrderSec.o \
	ShSvMainSec.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

ShoppingServiceSec.cgi: \
	SvCmn.o \
	SvSecCmn.o \
	ShSvCmn.o \
	ShSvGetProductCount.o \
	ShSvGetProductSpec.o \
	ShSvGetStockQty.o \
	ShSvPlaceOrderSec.o \
	ShSvMainSec.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

ShSvMainSec.cgi.o: ShSvMainSec.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<


## Install Programs and Data

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exist."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir); \
	done

cgi-client-programs-install: $(cgi_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exist."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

cgi-client-datas-install: $(CLIENT_HTML_FILES) $(cgi_client_USEKEYFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR)/$(CLIENT_HTML_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR)/$(CLIENT_HTML_DIR) exist."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR)/$(CLIENT_HTML_DIR) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)/$(CLIENT_HTML_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR)/$(CLIENT_HTML_DIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			-m 0644 \
			$$f $(DESTDIR)$(CGI_BIN_DIR)/$$f; \
	done

cgi-client-install: cgi-client-programs-install cgi-client-datas-install
#
client-install: console-client-install cgi-client-install

#
service-conf-install: $(service_CONFFILES)
	@if test -d $(DESTDIR)$(serviceconfdir); then \
		echo "$(DESTDIR)$(serviceconfdir) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(serviceconfdir)."; \
		mkdir -p $(DESTDIR)$(serviceconfdir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(serviceconfdir)."; \
		$(INSTALL_PROGRAM) -m 0666 \
			$$f $(DESTDIR)$(serviceconfdir); \
		for k in $(cgi_client_USEKEYFILES); do \
			echo "$(CGI_BIN_DIR)/$$k" >> \
			$(DESTDIR)$(serviceconfdir)/$$f; \
		done; \
	done

service-datas-install: $(service_DATAFILES)
	@if test -d $(DESTDIR)$(servicedatadir); then \
		echo "$(DESTDIR)$(servicedatadir) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(servicedatadir)."; \
		mkdir -p $(DESTDIR)$(servicedatadir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(servicedatadir)."; \
		$(INSTALL_PROGRAM) \
			-m 0666 \
			$$f $(DESTDIR)$(servicedatadir); \
	done

service-usekeys-install: $(service_USEKEYFILES)
	@if test -d $(DESTDIR)$(servicekeysdir); then \
		echo "$(DESTDIR)$(servicekeysdir) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(servicekeysdir)."; \
		mkdir -p $(DESTDIR)$(servicekeysdir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(servicekeysdir)."; \
		$(INSTALL_PROGRAM) \
			-m 0644 \
			$$f $(DESTDIR)$(servicekeysdir); \
	done

service-common-install: service-conf-install service-datas-install service-usekeys-install

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSMLDIR); then \
		echo "$(DESTDIR)$(SSMLDIR) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSMLDIR)."; \
		mkdir -p $(DESTDIR)$(SSMLDIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(SSMLDIR)."; \
		$(INSTALL_PROGRAM) \
			-m 0644 \
			$$f $(DESTDIR)$(SSMLDIR); \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exist."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir); \
	done

stdio-service-install: service-common-install stdio-service-programs-install ssml-install

#
cgi-service-programs-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exist."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

cgi-service-install: service-common-install cgi-service-programs-install

service-install: cgi-service-install stdio-service-install

#
sample-install: client-install service-install

# 
install: cgi-client-install service-install

#
clean: 
	rm -f $(OBJS) $(PROGRAMS)


## Test Service Programs for Success Cases

stest1:
	cat SampleMessages/GetProductCountSecReq.xml | ./ShoppingServiceSec.cgi
stest2:	    
	cat SampleMessages/GetProductSpecSecReq.xml | ./ShoppingServiceSec.cgi
stest3:	    
	cat SampleMessages/GetStockQtySecReq.xml | ./ShoppingServiceSec.cgi
stest4:	    
	cat SampleMessages/PlaceOrderSecReq.xml | ./ShoppingServiceSec.cgi


## Test Client-Service Hookups for Success Cases

ctest1:
	./ShoppingClientSec -s http://localhost/cgi-bin/ShoppingServiceSec.cgi -c EUC-JP GetProductList
ctest2:
	./ShoppingClientSec -s http://localhost/cgi-bin/ShoppingServiceSec.cgi -c EUC-JP GetStockQty NS01
ctest3:
	./ShoppingClientSec -s http://localhost/cgi-bin/ShoppingServiceSec.cgi -c EUC-JP -b pubKey_ShoppingService.pem -v privKey_ShoppingClient.pem PlaceOrder NS01 1


## Test Client-Server-Service Hookups for Success Cases

cstest1:
	./ShoppingClientSec -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP GetProductList
cstest2:
	./ShoppingClientSec -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP GetStockQty NS01
cstest3:
	./ShoppingClientSec -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP -b pubKey_ShoppingService.pem -v privKey_ShoppingClient.pem PlaceOrder NS01 1
