/*-----------------------------------------------------------------------------
 * $RCSfile: daemon.c,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

int
daemon(int nochdir,
	   int noclose) {
	pid_t pid = fork();

	if (pid < 0) {
		/* fork failed */
		return -1;
	}
	else if (pid != 0) {
		/* parent is exit */
		exit(0); 
	}

	/* set session leader */
	if (-1 == setsid()) {
		return -1;
	}

	if (!nochdir) {
		/* chdir / */
		chdir("/");
	}

	if (!noclose) {
		int fd = open("/dev/null", O_RDWR);
		if (-1 != fd) {
			dup2(fd, 0);
			dup2(fd, 1);
			dup2(fd, 2);
		}
	}

	return 0;
}
