/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ChannelDescriptor.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef ChannelDescriptor_H
#define ChannelDescriptor_H

#include <string>

#include "Defines.h"

namespace OpenSOAP {

  //vZXԒʐMpt@CfBXNv^NX
  class ChannelDescriptor {

    friend class ChannelSelector;
    friend class ChannelManager;

  public:
	OPENSOAP_VAR
    ChannelDescriptor();
	OPENSOAP_VAR
    ChannelDescriptor(const ChannelDescriptor& aDesc);
	OPENSOAP_VAR
    virtual ~ChannelDescriptor();

	OPENSOAP_VAR
    int read(std::string& aReadData);
	OPENSOAP_VAR
    int write(const std::string& aWriteData);

    enum WAIT_OPT { 
      WAIT_NOLIMIT = -1, // max 180sec.
      NO_WAIT      = 0 
    };
    
  protected:
    ChannelDescriptor(const std::string& aId);

    const std::string& getId() const { return id_; }
    void setId(const std::string& id);
    
  public:
	OPENSOAP_VAR
    void setReadFd(const int fd);
	OPENSOAP_VAR
    void setWriteFd(const int fd);
	OPENSOAP_VAR
    int& getReadFd();
	OPENSOAP_VAR
    int& getWriteFd();

  protected:
    //public:
    std::string id_;
    int readFd_;
    int writeFd_;

  };

} // end of namespace OpenSOAP


#endif /* ChannelDescriptor_H */
