/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ServerCommon.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef ServerCommon_H
#define ServerCommon_H

#include <string>
#include "Defines.h"

namespace OpenSOAP {

  // for LOG
  static const std::string TAG_ERR = "*** E ***:";
  static const std::string TAG_WRN = "*** W ***:";
  static const std::string TAG_INF = "*** I ***:";

  //keyword
  //static const std::string FILE_PATH_DELMIT = "/";
  static const char FILE_PATH_DELMIT = '/';

  //-------------------------------------------
  //ʊ֐
  //lbg[Nread/writeC^[tF[X(Socket/FIFO)
  OPENSOAP_VAR
  extern int read(int aFd, std::string& aData);
  OPENSOAP_VAR
  extern int write(int aFd, const std::string& aData);
#if !defined(WIN32)
  extern int read2(int aFd, std::string& aData);
#endif
  //-------------------------------------------

  // Service Connection Type
  // added 2002.03.11
  static const std::string SRV_CONNCT_SOCKET = "Socket";
  static const std::string SRV_CONNCT_STDIO  = "StdIO";
  static const std::string SRV_CONNCT_FIFO   = "FIFO";
  static const std::string SRV_CONNCT_IPC    = "IPC";
  static const std::string SRV_CONNCT_MODULE = "Module";
  static const std::string SRV_CONNCT_COM    = "COM";
  // etc...

  // Socket Address 
#if defined(WIN32)
  static const int MSGDRV_SOCKET_ADDR 
	= 7101;
  static const int SYNC_SRVDRV_SOCKET_ADDR 
	= 7102;
  static const int ASYNC_SRVDRV_SOCKET_ADDR 
	= 7103;
  static const int SRV_SOCKET_ADDR 
	= 7104;
  static const int FIFOSRV_SOCKET_ADDR 
	= 7105;
  static const int FWDER_SOCKET_ADDR 
	= 7106;
  static const int IDMGR_SOCKET_ADDR 
	= 7107;
  static const int SSMLATTRMGR_SOCKET_ADDR 
	= 7108;
  static const int SRVCONFATTRMGR_SOCKET_ADDR 
	= 7109;
  static const int FWDQUEUE_SOCKET_ADDR 
	= 7110;
  static const int REQQUEUE_SOCKET_ADDR 
	= 7111;
  static const int RESSPOOL_SOCKET_ADDR 
	= 7112;
  static const int TTLMGR_SOCKET_ADDR 
	= 7113;

  // path to temporal file directory
  static const std::string OPENSOAP_TMP_PATH = "/OpenSOAP/var/";
  static const std::string SERVER_CONF_TAG = "/server_conf";
#else
  //static const std::string SOCKET_PATH = "SOCKET/";
  
  static const std::string MSGDRV_SOCKET_ADDR = "MsgDrv";
  static const std::string SYNC_SRVDRV_SOCKET_ADDR = "SyncSrvDrv";
  static const std::string ASYNC_SRVDRV_SOCKET_ADDR = "AsyncSrvDrv";
  static const std::string SRV_SOCKET_ADDR = "Srv";
  static const std::string FIFOSRV_SOCKET_ADDR = "FIFOSrv";
  static const std::string FWDER_SOCKET_ADDR = "Fwder";
  static const std::string IDMGR_SOCKET_ADDR = "IdManager";
  static const std::string SSMLATTRMGR_SOCKET_ADDR = "SSMLAttrMgr";
  static const std::string SRVCONFATTRMGR_SOCKET_ADDR = "SrvConfAttrMgr";
  static const std::string FWDQUEUE_SOCKET_ADDR = "FwdQueue";
  static const std::string REQQUEUE_SOCKET_ADDR = "ReqQueue";
  static const std::string RESSPOOL_SOCKET_ADDR = "ResSpool";
  static const std::string TTLMGR_SOCKET_ADDR = "TTLManager";
#endif

  // PID File
  //static const std::string PID_FILE_PATH = "run/";
  
  static const std::string MSGDRV_PID_FILE = "msgDrvCreator.pid";
  static const std::string SYNC_SRVDRV_PID_FILE = "srvDrvCreator_sync.pid";
  static const std::string ASYNC_SRVDRV_PID_FILE = "srvDrvCreator_async.pid";
  static const std::string SRV_PID_FILE = "Srv.pid";
  static const std::string FIFOSRV_PID_FILE = "FIFOSrv.pid";
  static const std::string FWDER_PID_FILE = "fwderCreator.pid";
  static const std::string IDMGR_PID_FILE = "idManager.pid";
  static const std::string SSMLATTRMGR_PID_FILE = "ssmlAttrMgr.pid";
  static const std::string SRVCONFATTRMGR_PID_FILE = "srvConfAttrMgr.pid";
  static const std::string FWDQUEUE_PID_FILE = "queueManager_fwd.pid";
  static const std::string REQQUEUE_PID_FILE = "queueManager_req.pid";
  static const std::string RESSPOOL_PID_FILE = "spoolManager.pid";
  static const std::string TTLMGR_PID_FILE = "ttlManager.pid";

  // table
  //static const std::string TABLE_FILE_PATH = "Data/Table/";
  
  static const std::string REQQUEUE_TABLE_FILE = "req_queue_table";
  static const std::string FWDQUEUE_TABLE_FILE = "fwd_queue_table";
  static const std::string RESSPOOL_TABLE_FILE = "res_spool_table";
  static const std::string TTL_TABLE_FILE = "ttl_table";

  // Private Key
  static const std::string SECURITY_DATA_PRIV_KEY = "privKey.pem";

  // SOAP message

} // end of namespace OpenSOAP


#endif /* ServerCommon_H */
